// Copyright 2013 The Flutter Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.
// Autogenerated from Pigeon, do not edit directly.
// See also: https://pub.dev/packages/pigeon

#ifndef PIGEON_MESSAGES_G_H_
#define PIGEON_MESSAGES_G_H_

#include <flutter_linux/flutter_linux.h>

G_BEGIN_DECLS

/**
 * PigeonExamplePackageCode:
 * PIGEON_EXAMPLE_PACKAGE_CODE_ONE:
 * PIGEON_EXAMPLE_PACKAGE_CODE_TWO:
 *
 */
typedef enum {
  PIGEON_EXAMPLE_PACKAGE_CODE_ONE = 0,
  PIGEON_EXAMPLE_PACKAGE_CODE_TWO = 1
} PigeonExamplePackageCode;

/**
 * PigeonExamplePackageMessageData:
 *
 */

G_DECLARE_FINAL_TYPE(PigeonExamplePackageMessageData,
                     pigeon_example_package_message_data,
                     PIGEON_EXAMPLE_PACKAGE, MESSAGE_DATA, GObject)

/**
 * pigeon_example_package_message_data_new:
 * name: field in this object.
 * description: field in this object.
 * code: field in this object.
 * data: field in this object.
 *
 * Creates a new #MessageData object.
 *
 * Returns: a new #PigeonExamplePackageMessageData
 */
PigeonExamplePackageMessageData* pigeon_example_package_message_data_new(
    const gchar* name, const gchar* description, PigeonExamplePackageCode code,
    FlValue* data);

/**
 * pigeon_example_package_message_data_get_name
 * @object: a #PigeonExamplePackageMessageData.
 *
 * Gets the value of the name field of @object.
 *
 * Returns: the field value.
 */
const gchar* pigeon_example_package_message_data_get_name(
    PigeonExamplePackageMessageData* object);

/**
 * pigeon_example_package_message_data_get_description
 * @object: a #PigeonExamplePackageMessageData.
 *
 * Gets the value of the description field of @object.
 *
 * Returns: the field value.
 */
const gchar* pigeon_example_package_message_data_get_description(
    PigeonExamplePackageMessageData* object);

/**
 * pigeon_example_package_message_data_get_code
 * @object: a #PigeonExamplePackageMessageData.
 *
 * Gets the value of the code field of @object.
 *
 * Returns: the field value.
 */
PigeonExamplePackageCode pigeon_example_package_message_data_get_code(
    PigeonExamplePackageMessageData* object);

/**
 * pigeon_example_package_message_data_get_data
 * @object: a #PigeonExamplePackageMessageData.
 *
 * Gets the value of the data field of @object.
 *
 * Returns: the field value.
 */
FlValue* pigeon_example_package_message_data_get_data(
    PigeonExamplePackageMessageData* object);

G_DECLARE_FINAL_TYPE(PigeonExamplePackageMessageCodec,
                     pigeon_example_package_message_codec,
                     PIGEON_EXAMPLE_PACKAGE, MESSAGE_CODEC,
                     FlStandardMessageCodec)

G_DECLARE_FINAL_TYPE(PigeonExamplePackageExampleHostApi,
                     pigeon_example_package_example_host_api,
                     PIGEON_EXAMPLE_PACKAGE, EXAMPLE_HOST_API, GObject)

G_DECLARE_FINAL_TYPE(PigeonExamplePackageExampleHostApiResponseHandle,
                     pigeon_example_package_example_host_api_response_handle,
                     PIGEON_EXAMPLE_PACKAGE, EXAMPLE_HOST_API_RESPONSE_HANDLE,
                     GObject)

G_DECLARE_FINAL_TYPE(
    PigeonExamplePackageExampleHostApiGetHostLanguageResponse,
    pigeon_example_package_example_host_api_get_host_language_response,
    PIGEON_EXAMPLE_PACKAGE, EXAMPLE_HOST_API_GET_HOST_LANGUAGE_RESPONSE,
    GObject)

/**
 * pigeon_example_package_example_host_api_get_host_language_response_new:
 *
 * Creates a new response to ExampleHostApi.getHostLanguage.
 *
 * Returns: a new #PigeonExamplePackageExampleHostApiGetHostLanguageResponse
 */
PigeonExamplePackageExampleHostApiGetHostLanguageResponse*
pigeon_example_package_example_host_api_get_host_language_response_new(
    const gchar* return_value);

/**
 * pigeon_example_package_example_host_api_get_host_language_response_new_error:
 * @code: error code.
 * @message: error message.
 * @details: (allow-none): error details or %NULL.
 *
 * Creates a new error response to ExampleHostApi.getHostLanguage.
 *
 * Returns: a new #PigeonExamplePackageExampleHostApiGetHostLanguageResponse
 */
PigeonExamplePackageExampleHostApiGetHostLanguageResponse*
pigeon_example_package_example_host_api_get_host_language_response_new_error(
    const gchar* code, const gchar* message, FlValue* details);

G_DECLARE_FINAL_TYPE(PigeonExamplePackageExampleHostApiAddResponse,
                     pigeon_example_package_example_host_api_add_response,
                     PIGEON_EXAMPLE_PACKAGE, EXAMPLE_HOST_API_ADD_RESPONSE,
                     GObject)

/**
 * pigeon_example_package_example_host_api_add_response_new:
 *
 * Creates a new response to ExampleHostApi.add.
 *
 * Returns: a new #PigeonExamplePackageExampleHostApiAddResponse
 */
PigeonExamplePackageExampleHostApiAddResponse*
pigeon_example_package_example_host_api_add_response_new(int64_t return_value);

/**
 * pigeon_example_package_example_host_api_add_response_new_error:
 * @code: error code.
 * @message: error message.
 * @details: (allow-none): error details or %NULL.
 *
 * Creates a new error response to ExampleHostApi.add.
 *
 * Returns: a new #PigeonExamplePackageExampleHostApiAddResponse
 */
PigeonExamplePackageExampleHostApiAddResponse*
pigeon_example_package_example_host_api_add_response_new_error(
    const gchar* code, const gchar* message, FlValue* details);

/**
 * PigeonExamplePackageExampleHostApiVTable:
 *
 * Table of functions exposed by ExampleHostApi to be implemented by the API
 * provider.
 */
typedef struct {
  PigeonExamplePackageExampleHostApiGetHostLanguageResponse* (
      *get_host_language)(gpointer user_data);
  PigeonExamplePackageExampleHostApiAddResponse* (*add)(int64_t a, int64_t b,
                                                        gpointer user_data);
  void (*send_message)(
      PigeonExamplePackageMessageData* message,
      PigeonExamplePackageExampleHostApiResponseHandle* response_handle,
      gpointer user_data);
} PigeonExamplePackageExampleHostApiVTable;

/**
 * pigeon_example_package_example_host_api_set_method_handlers:
 *
 * @messenger: an #FlBinaryMessenger.
 * @suffix: (allow-none): a suffix to add to the API or %NULL for none.
 * @vtable: implementations of the methods in this API.
 * @user_data: (closure): user data to pass to the functions in @vtable.
 * @user_data_free_func: (allow-none): a function which gets called to free
 * @user_data, or %NULL.
 *
 * Connects the method handlers in the ExampleHostApi API.
 */
void pigeon_example_package_example_host_api_set_method_handlers(
    FlBinaryMessenger* messenger, const gchar* suffix,
    const PigeonExamplePackageExampleHostApiVTable* vtable, gpointer user_data,
    GDestroyNotify user_data_free_func);

/**
 * pigeon_example_package_example_host_api_clear_method_handlers:
 *
 * @messenger: an #FlBinaryMessenger.
 * @suffix: (allow-none): a suffix to add to the API or %NULL for none.
 *
 * Clears the method handlers in the ExampleHostApi API.
 */
void pigeon_example_package_example_host_api_clear_method_handlers(
    FlBinaryMessenger* messenger, const gchar* suffix);

/**
 * pigeon_example_package_example_host_api_respond_send_message:
 * @response_handle: a #PigeonExamplePackageExampleHostApiResponseHandle.
 * @return_value: location to write the value returned by this method.
 *
 * Responds to ExampleHostApi.sendMessage.
 */
void pigeon_example_package_example_host_api_respond_send_message(
    PigeonExamplePackageExampleHostApiResponseHandle* response_handle,
    gboolean return_value);

/**
 * pigeon_example_package_example_host_api_respond_error_send_message:
 * @response_handle: a #PigeonExamplePackageExampleHostApiResponseHandle.
 * @code: error code.
 * @message: error message.
 * @details: (allow-none): error details or %NULL.
 *
 * Responds with an error to ExampleHostApi.sendMessage.
 */
void pigeon_example_package_example_host_api_respond_error_send_message(
    PigeonExamplePackageExampleHostApiResponseHandle* response_handle,
    const gchar* code, const gchar* message, FlValue* details);

G_DECLARE_FINAL_TYPE(
    PigeonExamplePackageMessageFlutterApiFlutterMethodResponse,
    pigeon_example_package_message_flutter_api_flutter_method_response,
    PIGEON_EXAMPLE_PACKAGE, MESSAGE_FLUTTER_API_FLUTTER_METHOD_RESPONSE,
    GObject)

/**
 * pigeon_example_package_message_flutter_api_flutter_method_response_is_error:
 * @response: a #PigeonExamplePackageMessageFlutterApiFlutterMethodResponse.
 *
 * Checks if a response to MessageFlutterApi.flutterMethod is an error.
 *
 * Returns: a %TRUE if this response is an error.
 */
gboolean
pigeon_example_package_message_flutter_api_flutter_method_response_is_error(
    PigeonExamplePackageMessageFlutterApiFlutterMethodResponse* response);

/**
 * pigeon_example_package_message_flutter_api_flutter_method_response_get_error_code:
 * @response: a #PigeonExamplePackageMessageFlutterApiFlutterMethodResponse.
 *
 * Get the error code for this response.
 *
 * Returns: an error code or %NULL if not an error.
 */
const gchar*
pigeon_example_package_message_flutter_api_flutter_method_response_get_error_code(
    PigeonExamplePackageMessageFlutterApiFlutterMethodResponse* response);

/**
 * pigeon_example_package_message_flutter_api_flutter_method_response_get_error_message:
 * @response: a #PigeonExamplePackageMessageFlutterApiFlutterMethodResponse.
 *
 * Get the error message for this response.
 *
 * Returns: an error message.
 */
const gchar*
pigeon_example_package_message_flutter_api_flutter_method_response_get_error_message(
    PigeonExamplePackageMessageFlutterApiFlutterMethodResponse* response);

/**
 * pigeon_example_package_message_flutter_api_flutter_method_response_get_error_details:
 * @response: a #PigeonExamplePackageMessageFlutterApiFlutterMethodResponse.
 *
 * Get the error details for this response.
 *
 * Returns: (allow-none): an error details or %NULL.
 */
FlValue*
pigeon_example_package_message_flutter_api_flutter_method_response_get_error_details(
    PigeonExamplePackageMessageFlutterApiFlutterMethodResponse* response);

/**
 * pigeon_example_package_message_flutter_api_flutter_method_response_get_return_value:
 * @response: a #PigeonExamplePackageMessageFlutterApiFlutterMethodResponse.
 *
 * Get the return value for this response.
 *
 * Returns: a return value.
 */
const gchar*
pigeon_example_package_message_flutter_api_flutter_method_response_get_return_value(
    PigeonExamplePackageMessageFlutterApiFlutterMethodResponse* response);

/**
 * PigeonExamplePackageMessageFlutterApi:
 *
 */

G_DECLARE_FINAL_TYPE(PigeonExamplePackageMessageFlutterApi,
                     pigeon_example_package_message_flutter_api,
                     PIGEON_EXAMPLE_PACKAGE, MESSAGE_FLUTTER_API, GObject)

/**
 * pigeon_example_package_message_flutter_api_new:
 * @messenger: an #FlBinaryMessenger.
 * @suffix: (allow-none): a suffix to add to the API or %NULL for none.
 *
 * Creates a new object to access the MessageFlutterApi API.
 *
 * Returns: a new #PigeonExamplePackageMessageFlutterApi
 */
PigeonExamplePackageMessageFlutterApi*
pigeon_example_package_message_flutter_api_new(FlBinaryMessenger* messenger,
                                               const gchar* suffix);

/**
 * pigeon_example_package_message_flutter_api_flutter_method:
 * @api: a #PigeonExamplePackageMessageFlutterApi.
 * @a_string: (allow-none): parameter for this method.
 * @cancellable: (allow-none): a #GCancellable or %NULL.
 * @callback: (scope async): (allow-none): a #GAsyncReadyCallback to call when
 * the call is complete or %NULL to ignore the response.
 * @user_data: (closure): user data to pass to @callback.
 *
 */
void pigeon_example_package_message_flutter_api_flutter_method(
    PigeonExamplePackageMessageFlutterApi* api, const gchar* a_string,
    GCancellable* cancellable, GAsyncReadyCallback callback,
    gpointer user_data);

/**
 * pigeon_example_package_message_flutter_api_flutter_method_finish:
 * @api: a #PigeonExamplePackageMessageFlutterApi.
 * @result: a #GAsyncResult.
 * @error: (allow-none): #GError location to store the error occurring, or %NULL
 * to ignore.
 *
 * Completes a pigeon_example_package_message_flutter_api_flutter_method() call.
 *
 * Returns: a #PigeonExamplePackageMessageFlutterApiFlutterMethodResponse or
 * %NULL on error.
 */
PigeonExamplePackageMessageFlutterApiFlutterMethodResponse*
pigeon_example_package_message_flutter_api_flutter_method_finish(
    PigeonExamplePackageMessageFlutterApi* api, GAsyncResult* result,
    GError** error);

G_END_DECLS

#endif  // PIGEON_MESSAGES_G_H_
